//--------------------------------------------------------
// Delphi XE7 ł̃vOłB
// OpenDialogASaveDialog1Filterindex擾łȂ
// WI{^ŕۑt@C`IĂ܂B
//--------------------------------------------------------
unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Ani, FMX.Layouts, FMX.Gestures, FMX.StdCtrls,
  FMX.ExtCtrls;

type
  TForm1 = class(TForm)
    ToolbarHolder: TLayout;
    ToolbarPopup: TPopup;
    ToolbarPopupAnimation: TFloatAnimation;
    ToolBar1: TToolBar;
    ToolbarApplyButton: TButton;
    ToolbarCloseButton: TButton;
    ToolbarAddButton: TButton;
    Button1: TButton;
    ImageViewer1: TImageViewer;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Button2: TButton;
    procedure ToolbarCloseButtonClick(Sender: TObject);
    procedure FormGesture(Sender: TObject;
      const EventInfo: TGestureEventInfo; var Handled: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FGestureOrigin: TPointF;
    FGestureInProgress: Boolean;
    { private 錾 }
    procedure ShowToolbar(AShow: Boolean);
  public
    { public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if Key = vkEscape then
    ShowToolbar(not ToolbarPopup.IsOpen);
end;

procedure TForm1.ToolbarCloseButtonClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    ImageViewer1.Bitmap.LoadFromFile(OpenDialog1.FileName);
    Button2.Enabled := True;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Fname     : string;
begin
  SaveDialog1.FilterIndex := 1;
  if RadioButton1.IsChecked then SaveDialog1.Filter := 'rbg}bv|*bmp';
  if RadioButton2.IsChecked then SaveDialog1.Filter := 'WFCyO|*.jpg;*.jpeg';
  if RadioButton3.IsChecked then SaveDialog1.Filter := 'sO|*.png';
  if RadioButton4.IsChecked then SaveDialog1.Filter := 'eBt|*.tif;*.tiff';
  if RadioButton5.IsChecked then SaveDialog1.Filter := 'Mt|*.gif';
  if SaveDialog1.Execute then begin
    Fname := SaveDialog1.FileName;
  end
  else Exit;
  if RadioButton1.IsChecked then Fname := ChangeFileExt(SaveDialog1.FileName,'.bmp');     // gq̐ݒ
  if RadioButton2.IsChecked then Fname := ChangeFileExt(SaveDialog1.FileName,'.jpg');
  if RadioButton3.IsChecked then Fname := ChangeFileExt(SaveDialog1.FileName,'.png');
  if RadioButton4.IsChecked then Fname := ChangeFileExt(SaveDialog1.FileName,'.tif');
  if RadioButton5.IsChecked then Fname := ChangeFileExt(SaveDialog1.FileName,'.gif');
  ImageViewer1.Bitmap.SaveToFile(Fname, nil);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Button2.Enabled := False;
end;

procedure TForm1.FormGesture(Sender: TObject;
  const EventInfo: TGestureEventInfo; var Handled: Boolean);
var
  DX, DY : Single;
begin
  if EventInfo.GestureID = igiPan then
  begin
    if (TInteractiveGestureFlag.gfBegin in EventInfo.Flags)
      and ((Sender = ToolbarPopup)
        or (EventInfo.Location.Y > (ClientHeight - 70))) then
    begin
      FGestureOrigin := EventInfo.Location;
      FGestureInProgress := True;
    end;

    if FGestureInProgress and (TInteractiveGestureFlag.gfEnd in EventInfo.Flags) then
    begin
      FGestureInProgress := False;
      DX := EventInfo.Location.X - FGestureOrigin.X;
      DY := EventInfo.Location.Y - FGestureOrigin.Y;
      if (Abs(DY) > Abs(DX)) then
        ShowToolbar(DY < 0);
    end;
  end;
end;

procedure TForm1.ShowToolbar(AShow: Boolean);
begin
  ToolbarPopup.Width := ClientWidth;
  ToolbarPopup.PlacementRectangle.Rect := TRectF.Create(0, ClientHeight-ToolbarPopup.Height, ClientWidth-1, ClientHeight-1);
  ToolbarPopupAnimation.StartValue := ToolbarPopup.Height;
  ToolbarPopupAnimation.StopValue := 0;

  ToolbarPopup.IsOpen := AShow;
end;

end.

