//----------------------------------------------------
// Tifft@C̓ǂݍ݂WICoRɂȂ܂B
// Tiff`t@C̏o͂̓vNĂ܂B
//----------------------------------------------------
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, System.UITypes;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    FileSaveBtn: TButton;
    FileOpenBtn: TButton;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    magnificationEdit: TLabeledEdit;
    ReDisplay: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    procedure FormCreate(Sender: TObject);
    procedure ReDisplayClick(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure Imageout(Image: TBitmap);
    procedure AutoSize_imageout(Image: TBitmap);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Jpeg, GifImg, PNGImage;

const

  OpenFileFilter =
    'bmp|*.bmp' +
    '|wmf|*.wmf' +
    '|emf|*.emf' +
    '|ico|*.ico' +
    '|tif|*.tif;*tiff' +
    '|png|*.png' +
    '|jpg|*.jpg;*.jpeg' +
    '|gif|*.gif';

  SaveFileFilter =
    'bmp|*.bmp' +
    '|png|*.png' +
    '|jpg|*.jpg' +
    '|gif|*.gif';

   ImageHWC   = 440;                            // \gTCY
var
  InputImage    : TImage;                       // 摜͗p
  OutBitmap     : Tbitmap;                      // 摜prbg}bv
  Findex        : integer;                      // t@CCfbNX

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : TRect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := Round(Image.Width * magnification);
  MH := Round(Image.Height * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                        // ϔ{o
end;

//----------------------------------------------------
// Jt@C̉摜\ o͘gɍ킹ĕϔ{o
//----------------------------------------------------
procedure TForm1.AutoSize_imageout(Image: TBitmap);
begin
  if Image.Width >= Image.Height then begin
    Image1.Width := ImageHWC - 6;
    image1.Height := round((ImageHWC - 6) * image.Height / Image.Width);
  end
  else begin
    Image1.Height := ImageHWC - 6;
    image1.Width := round((ImageHWC - 6) * image.Width / Image.Height);
  end;
  Image1.Picture.Bitmap.SetSize(Image1.Width, image1.Height);
  Image1.Canvas.StretchDraw(Rect(0, 0, Image1.Width, image1.Height), Image);    // o͘gɕϔ{o
  magnificationEdit.Text := floatTostrF(Image1.Width / Image.Width, ffGeneral, 4, 2);
end;

//-------------------
// \@̑I
//-------------------
procedure TForm1.ReDisplayClick(Sender: TObject);
begin
  if RadioButton2.Checked then imageout(OutBitmap);           // ϔ{o
  if RadioButton1.Checked then AutoSize_imageout(OutBitmap);  // o͘gɍ킹ĕϔ{o
end;

//----------------------------------------------------------------------------
// 摜t@C̓ǂݍ
// Tiff`̃t@CWICoRƂȂ܂B
// ^`̃t@C wmf  emf  \݂̂łB
// ^`̃t@CȊOrbg}bv`ɕϊ\Ă܂B
// 摜t@CTImage ɓǂݍł TBitmapɕϊĂ܂B
// TBitmap̓rbg}bvt@Cǂݍ߂Ȃ̂TImageoRĂ܂B
//----------------------------------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  VRect : TRect;
  IPng  : TPNGImage;
  IJpeg : TJPEGImage;
  IGif  : TGIFImage;
  exstr : string;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  // \摜̏
  case Findex of
    1,4,5,
    6,7,8 : begin
              Image1.Canvas.Brush.Style := bsSolid;
              Image1.Canvas.Brush.Color := clBtnface;
              Image1.Canvas.FillRect(VRect);                  // Canvas 摜
            end;
    2,3:    begin
              Image1.Picture.Assign(nil);                     // Picturẻ ʏ
            end;
  end;
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  OpenPictureDialog1.FileName := '';
  if OpenPictureDialog1.Execute = true then                   // t@Cw肳ꂽ
    begin
      FileSaveBtn.Enabled := False;
//      Findex := OpenPictureDialog1.FilterIndex;
      exstr := ExtractFileExt(OpenPictureDialog1.FileName);   // gq̎o
      exstr := LowerCase(exstr);                              // ϊ
      Findex := 0;
      if (exstr = '.bmp') or (exstr = '.ico') or (exstr = '.tif') then Findex := 1;
      if (exstr = '.wmf') or (exstr = '.emf')                     then Findex := 2;
      if (exstr = '.png')                                         then Findex := 6;
      if (exstr = '.jpg') or (exstr = '.jpeg')                    then Findex := 7;
      if (exstr = '.gif')                                         then Findex := 8;
      Image1.AutoSize := False;
      Image1.Width  := ImageHWC div 2;
      Image1.Height := ImageHWC div 2;
      case Findex of
        1,4,5:  begin
                  InputImage.Picture.LoadFromFile(OpenPictureDialog1.FileName);    // BITMAP摜̓ǂݍ
                end;
        2,3:    begin
                  Image1.AutoSize := True;
                  Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);        // ^摜\̂
                  exit;
                end;
        6:      begin
                  IPng := TPNGImage.Create;
                  IPng.LoadFromFile(OpenPictureDialog1.FileName);                  // PNG摜̓ǂݍ
                  InputImage.Picture.Assign(IPng);
                  IPng.Free;
                end;
        7:      begin
                  IJpeg := TJPEGImage.Create;
                  IJpeg.LoadFromFile(OpenPictureDialog1.FileName);                 // JPEG摜̓ǂݍ
                  InputImage.Picture.Assign(IJpeg);
                  IJpeg.Free;
                end;
        8:      begin
                  IGif := TGIFImage.Create;
                  IGif.LoadFromFile(OpenPictureDialog1.FileName);                  // GIF摜̓ǂݍ
                  InputImage.Picture.Assign(IGif);
                  IGif.Free;
                end
        else exit;                                           // wO̊gqȂI
      end;
    end
    else exit;                                               // t@C̎w肪ΏI
  OutBitmap.Assign(nil);                                     // rbg}bv̉
  OutBitmap.Assign(InputImage.Picture.Graphic);              // rbg}bvɊ֘At
  if RadioButton2.Checked then imageout(OutBitmap);          // o͘gɕϔ{o
  if RadioButton1.Checked then AutoSize_imageout(OutBitmap); // o͘gɍ킹Ăɕϔ{o
  FileSaveBtn.Enabled := True;
end;

//------------------------------------------------------------------
// ^`̃t@C wmf  emf  ۑł܂B
// Tiff ` WIC gpvOQƂĂB
//------------------------------------------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  IPng  : TPNGImage;
  IJpeg : TJPEGImage;
  IGif  : TGIFImage;
  exstr : string;
  Fname : string;
  FnameTop : string;
  Fint  : integer;
begin
  SavePictureDialog1.Filter := SaveFileFilter;
  if not SavePictureDialog1.Execute then exit;
  exstr := ExtractFileExt(SavePictureDialog1.FileName);                 // gq̎o
  if exstr = '' then begin                                              // gqȂ
    case SavePictureDialog1.FilterIndex of
      1 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
      2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
      3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');
      4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;

  exstr := ExtractFileExt(Fname);                                       // gq̎o
  FnameTop := ExtractFileName(Fname);                                   // t@Co
  if Length(FnameTop) = Length(exstr) then begin                        // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;
  if FileExists(Fname) then                                             // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;
  exstr := LowerCase(exstr);                                            // ϊ
  Fint := 0;
  if (exstr = '.bmp')                       then Fint := 1;
  if (exstr = '.png')                       then Fint := 6;
  if (exstr = '.jpg') or (exstr = '.jpeg')  then Fint := 7;
  if (exstr = '.gif')                       then Fint := 8;
  case Fint of
    1:  begin
          OutBitmap.SaveToFile(Fname);
        end;
    6:  begin
          IPng := TPNGImage.Create;
          IPng.Assign(OutBitmap);
          IPng.SaveToFile(Fname);
          IPng.Free;
        end;
    7:  begin
          IJpeg := TJPEGImage.Create;
          IJpeg.Assign(OutBitmap);
          IJpeg.SaveToFile(Fname);
          IJpeg.Free;
        end;
    8:  begin
          IGif := TGifImage.Create;
          IGif.Assign(OutBitmap);
          IGif.SaveToFile(Fname);
          IGif.Free;
        end;
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  Image1.Top := 0;
  Image1.Left := 0;
  InputImage  := Timage.Create(nil);
  InputImage.AutoSize := true;
  OutBitmap := Tbitmap.Create;
  FileSaveBtn.Enabled := False;
  Findex := 0;
end;

// I
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputImage.Free;
  OutBitmap.Free;
end;

end.
