//----------------------------------------------------------------------------
// TBitmapgpĂ܂AgpȂĂt@Cϊ͉\łB
// LgpΕϔ{`\łB
// Graphics := TGPGraphics.Create(Image1.Canvas.Handle);
// Graphics.DrawImage(GPBitmap, MakeRect(0, 0, Image1.Width, image1.Height));
// TBitmap͉摜sƂOɎgpĂ܂B
//----------------------------------------------------------------------------
unit GdIPFileConvMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, System.UITypes,
  Vcl.Graphics,Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ExtDlgs;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    FileSaveBtn: TButton;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    magnificationEdit: TLabeledEdit;
    ReDisplay: TButton;
    FileOpenBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ReDisplayClick(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    procedure Imageout(Image: TBitmap);
    procedure trimming_imageout(Image: TBitmap);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
    GDIPAPI, GDIPOBJ, GDIPUTIL;

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.emf;*.wmf;*.ico' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.emf|*.emf' +
    '|*.wmf|*.wmf' +
    '|*.ico|*.ico';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif';

  ImageHWC   = 440;                           // \gTCY

var
  OutputBitmap  : TBitmap;                    // 摜ۑprbg}bv

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : TRect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := Round(Image.Width * magnification);
  MH := Round(Image.Height * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                        // ϔ{o
end;

//----------------------------------------------------
// Jt@C̉摜\ o͘gɍ킹ĕϔ{o
//----------------------------------------------------
procedure TForm1.trimming_imageout(Image: TBitmap);
begin
  if Image.Width >= Image.Height then begin
    Image1.Width := ImageHWC - 6;
    image1.Height := round((ImageHWC - 6) * image.Height / Image.Width);
  end
  else begin
    Image1.Height := ImageHWC - 6;
    image1.Width := round((ImageHWC - 6) * image.Width / Image.Height);
  end;
  Image1.Picture.Bitmap.SetSize(Image1.Width, image1.Height);
  Image1.Canvas.StretchDraw(Rect(0, 0, Image1.Width, image1.Height), Image);    // o͘gɕϔ{o
  magnificationEdit.Text := floatTostrF(Image1.Width / Image.Width, ffGeneral, 4, 2);
end;

//--------------------
// \@̑I
//--------------------
procedure TForm1.ReDisplayClick(Sender: TObject);
begin
  if RadioButton2.Checked then imageout(OutputBitmap);           // ϔ{o
  if RadioButton1.Checked then trimming_imageout(OutputBitmap);  // o͘gɍ킹ĕϔ{o
end;

//--------------------------------------------------------------
// t@CJGDI+bitmapɓǂݍ݂܂
// GDI+̏݃nhTbitmap̃nhɐݒ
// GDI+bitmapTbitmapɏ݂܂
// Iꂽϔ{@TbitmapTimageɏݕ\܂B
// Tbitmap OutputBitmap͌摜f[^[ۑpɎgpĂ܂
// OutputBitmapȗƂ͉\łB
//--------------------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  Graphics  : TGPGraphics;
  GPBitmap  : TGPBitmap;
  VRect     : TRect;                      // \TCYݒp
begin
  FileSaveBtn.Enabled := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      GPBitmap := TGPBitmap.Create(OpenPictureDialog1.FileName);  // t@CƂ̊֘At
      OutputBitmap.Height := GPBitmap.GetHeight;
      OutputBitmap.Width  := GPBitmap.GetWidth;
      Graphics := TGPGraphics.Create(OutputBitmap.Canvas.Handle);
      try
        Graphics.DrawImage(GPBitmap, 0, 0, OutputBitmap.Width, OutputBitmap.Height);
      finally
        Graphics.Free;
        GPBitmap.Free;
      end;
    end
    else exit;
  if RadioButton2.Checked then imageout(OutputBitmap);          // o͘gɕϔ{o
  if RadioButton1.Checked then trimming_imageout(OutputBitmap); // o͘gɍ킹Ăɕϔ{o
  FileSaveBtn.Enabled := True;
end;

//----------------------------------------------------------------
// t@C̖OƎނIĕۑ܂B
// Tbitmap̃f[^[GDI+ɓn߂TMemoryStreamgp܂B
//----------------------------------------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  GPBitmap  : TGPBitmap;
  Astream   : TMemoryStream;
  Fname     : String;                                           // ۑpt@C
  ExeStr    : String;
  FnameTop  : String;
  Convstr   : String;
  Findex    : integer;
  LImgGUID  : TGUID;

  function GdipFormatSet: boolean;
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.png'   then begin Convstr := 'image/png';  Result := true; end;
    if ExeStr = '.jpg'   then begin Convstr := 'image/jpeg'; Result := true; end;
    if ExeStr = '.jpeg'  then begin Convstr := 'image/jpeg'; Result := true; end;
    if ExeStr = '.gif'   then begin Convstr := 'image/gif';  Result := true; end;
    if ExeStr = '.bmp'   then begin Convstr := 'image/bmp';  Result := true; end;
    if ExeStr = '.tif'   then begin Convstr := 'image/tiff'; Result := true; end;
    if ExeStr = '.tiff'  then begin Convstr := 'image/tiff'; Result := true; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);                  // gq̎o
  if ExeStr = '' then begin                                               // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                             // FilterIndexɂgq̐ݒ
    case Findex of
      2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');     // gq̐ݒ
      3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');
      4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
      5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
      6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                        // gqo
  if not GdipFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                     // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                         // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                               // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;
  // [Xg[쐬 OutputBitmap o
  Astream  := TMemoryStream.Create;
  OutputBitmap.SaveToStream(Astream);
  // [Xg[CTGPBitmap̃IuWFNgɓǂݍݎw
  GPBitmap := TGPBitmap.Create(TStreamAdapter.Create(AStream, soReference));
  try
    // t@C`w肵ď
    if GetEncoderClsid(Convstr, LImgGUID) >= 0 then GPBitmap.Save(Fname, LImgGUID);
  finally
    // [
    GPBitmap.Free;
    Astream.Free;
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  Image1.Top := 0;
  Image1.Left := 0;
  OutputBitmap  := TBitmap.Create;
  OutputBitmap.PixelFormat := pf32bit;
  FileSaveBtn.Enabled := False;
end;

// I
procedure TForm1.FormDestroy(Sender: TObject);
begin
  OutputBitmap.Free;
end;

end.
